import { CollectionReference, DocumentData, DocumentReference, Firestore, SetOptions, Transaction, WithFieldValue, WriteBatch } from "firebase/firestore";
import { UseMutationOptions } from "react-query";
export declare function useFirestoreCollectionMutation<T = DocumentData>(ref: CollectionReference<T>, useMutationOptions?: UseMutationOptions<DocumentReference<T>, Error, WithFieldValue<T>>): import("react-query").UseMutationResult<DocumentReference<T>, Error, WithFieldValue<T>, unknown>;
export declare function useFirestoreDocumentMutation<T = DocumentData>(ref: DocumentReference<T>, options?: SetOptions, useMutationOptions?: UseMutationOptions<void, Error, WithFieldValue<T>>): import("react-query").UseMutationResult<void, Error, WithFieldValue<T>, unknown>;
export declare function useFirestoreDocumentDeletion(ref: DocumentReference, useMutationOptions?: UseMutationOptions<void, Error, void>): import("react-query").UseMutationResult<void, Error, void, unknown>;
export declare function useFirestoreTransaction<T = void>(firestore: Firestore, updateFunction: (tsx: Transaction) => Promise<T>, useMutationOptions?: UseMutationOptions<T, Error, void>): import("react-query").UseMutationResult<T, Error, void, unknown>;
export declare function useFirestoreWriteBatch(batch: WriteBatch, useMutationOptions?: UseMutationOptions<void, Error, void>): import("react-query").UseMutationResult<void, Error, void, unknown>;
